package com.inca.npbusi.sacon.bms_sa_con_backexec;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.control.Hovcallback;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.pubsrv.stqtyhov.Dynstqty_hov;
import java.math.BigDecimal;
import org.apache.log4j.Category;

public class Bms_sales_detail extends CDetailModel implements Hovcallback {
   private Category a = Category.getInstance(Bms_sales_detail.class);
   private Dynstqty_hov b = new Dynstqty_hov();

   public Bms_sales_detail(CFrame var1, CMdeModel var2) {
      super(var1, "销售发货单细单", var2);
   }

   public String getTablename() {
      return "zx_bms_sa_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_beforeNew() {
      if (this.mdemodel.getMasterModel().getRow() >= 0 && this.mdemodel.getMasterModel().getRow() != this.mdemodel.getMasterModel().getRowCount()) {
         return "2".equals(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus")) && "0".equals(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "approveflag")) ? super.on_beforeNew() : -1;
      } else {
         return -1;
      }
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3;
      if ((var3 = this.getItemValue(var1, "discount")) != null && !var3.equals("") && !var3.equals("0") && !var3.equals("0.00")) {
         if (DecimalHelper.toDec(var3).compareTo(new BigDecimal("0")) < 0) {
            this.infoMessage("提示", "折扣不能小于零");
            return -1;
         } else {
            var3 = this.getItemValue(var1, "goodsqty");
            if (!"".equals(var3) && DecimalHelper.toDec(var3).compareTo(new BigDecimal("0")) > 0) {
               String var4;
               if ((var4 = this.getItemValue(var1, "posid")) != null && !var4.equals("") && !var4.equals("0")) {
                  DBTableModel var5 = null;
                  RemotesqlHelper var6 = new RemotesqlHelper();
                  var4 = "select * from bms_storer_pos where posid = " + var4;

                  try {
                     var5 = var6.doSelect(var4, 0, 1);
                  } catch (Exception var7) {
                     var7.printStackTrace();
                  }

                  if (var5.getRowCount() <= 0) {
                     return -1;
                  }

                  var4 = var5.getItemValue(0, "goodsunitflag");
                  if ("1".equals(var4)) {
                     var4 = this.getItemValue(var1, "packsize");
                     if (DecimalHelper.toDec(var3).remainder(DecimalHelper.toDec(var4)).compareTo(new BigDecimal("0")) != 0) {
                        this.infoMessage("提示", "整件货位的数量必须是整件！");
                        return -1;
                     }
                  }
               }

               return super.on_checkrow(var1, var2);
            } else {
               this.infoMessage("提示", "使用单位数量必须大于零");
               return -1;
            }
         }
      } else {
         this.infoMessage("提示", "折扣不能为空");
         return -1;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4;
      String var6;
      if (var2.equals("goodsid") && this.b(var1)) {
         var6 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var7 = this.getItemValue(var1, "goodsid");
         DBTableModel var8 = null;
         ClientRequest var9 = new ClientRequest();
         StringCommand var10 = new StringCommand("根据取价逻辑自动提取价格信息");
         ParamCommand var11;
         (var11 = new ParamCommand()).addParam("customid", var6);
         var11.addParam("goodsid", var7);
         var11.addParam("entryid", ((Bms_sales_mde)this.mdemodel).getEntryid());
         var9.addCommand(var10);
         var9.addCommand(var11);
         ServerResponse var16 = null;

         try {
            var16 = SendHelper.sendRequest(var9);
         } catch (Exception var13) {
            var13.printStackTrace();
         }

         if (((StringCommand)var16.commandAt(0)).getString().startsWith("+OK")) {
            if (var16.commandAt(1) instanceof DataCommand) {
               var8 = ((DataCommand)var16.commandAt(1)).getDbmodel();
            } else if (var16.commandAt(1) instanceof StringCommand) {
               var16.commandAt(1);
            }
         }

         String var19;
         if (var8 != null && var8.getRowCount() > 0) {
            var7 = var8.getItemValue(0, "price");
            var19 = var8.getItemValue(0, "priceid");
            this.setItemValue(var1, "priceid", var19);
            this.setItemValue(var1, "priceopcode", var8.getItemValue(0, "priceopcode"));
            this.setItemValue(var1, "pricename", var8.getItemValue(0, "pricename"));
            this.setItemValue(var1, "unitprice", var7);
            this.setItemValue(var1, "timepriceid", var8.getItemValue(0, "refrencepriceid"));
            this.setItemValue(var1, "timepricename", var8.getItemValue(0, "refrencepricename"));
            this.setItemValue(var1, "timeprice", var8.getItemValue(0, "refrenceprice"));
            this.setItemValue(var1, "discount", var8.getItemValue(0, "discount"));
            this.on_itemvaluechange(var1, "unitprice", var7);
         }

         var6 = this.getItemValue(var1, "goodsid");
         var7 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         ClientRequest var18 = new ClientRequest();
         StringCommand var20 = new StringCommand("Bms_sales_detail.取得上次销价类型信息");
         var10 = new StringCommand(var6);
         StringCommand var21 = new StringCommand(var7);
         var18.addCommand(var20);
         var18.addCommand(var10);
         var18.addCommand(var21);

         label95: {
            try {
               var16 = SendHelper.sendRequest(var18);
            } catch (Exception var14) {
               this.a.error("error", var14);
               this.errorMessage("错误", var14.getMessage());
               break label95;
            }

            if (((StringCommand)var16.commandAt(0)).getString().startsWith("+OK")) {
               var7 = ((StringCommand)var16.commandAt(1)).getString();
               var19 = ((StringCommand)var16.commandAt(2)).getString();
               var6 = ((StringCommand)var16.commandAt(3)).getString();
               this.setItemValue(var1, "lastpriceid", var7);
               this.setItemValue(var1, "lastpricename", var19);
               this.setItemValue(var1, "lastunitprice", var6);
            }
         }

         var4 = "";
         DBTableModel var5 = null;
         var6 = "select salestaxrate from pub_goods_v where goodsid = " + var3;
         RemotesqlHelper var17 = new RemotesqlHelper();

         try {
            var5 = var17.doSelect(var6, 0, 1);
         } catch (Exception var12) {
            var12.printStackTrace();
         }

         if (var5 != null && var5.getRowCount() > 0) {
            var4 = var5.getItemValue(0, "salestaxrate");
         }

         this.setItemValue(var1, "taxrate", var4);
         this.on_itemvaluechange(var1, "goodsuseqty", this.getItemValue(var1, "goodsuseqty"));
      }

      if (var2.equals("discount") || var2.equals("unitprice")) {
         if ((var4 = this.getItemValue(var1, "timeprice")).length() > 0 && DecimalHelper.toDec(var4).compareTo(new BigDecimal("0")) > 0) {
            if (var2.equals("discount")) {
               this.setItemValue(var1, "unitprice", DecimalHelper.multi(var4, var3, 10));
            }

            if (var2.equals("unitprice")) {
               this.setItemValue(var1, "discount", DecimalHelper.divide(var3, var4, 4));
            }
         }

         this.a(var1);
      }

      String var15;
      if ("goodsuseqty".equals(var2) && !"".equals(var3)) {
         if ((var4 = this.getItemValue(var1, "goodsuseunit")).indexOf("(") == -1) {
            var15 = "1";
         } else {
            var15 = var4.substring(var4.indexOf("(") + 1, var4.indexOf(")"));
         }

         var6 = DecimalHelper.multi(var3, var15, 6);
         this.setItemValue(var1, "goodsqty", var6);
         this.a(var1);
      }

      if ("goodsuseunit".equals(var2) && !"".equals(var3)) {
         var4 = this.getItemValue(var1, "goodsuseqty");
         if (var3.indexOf("(") == -1) {
            var15 = "1";
         } else {
            var15 = var3.substring(var3.indexOf("(") + 1, var3.indexOf(")"));
         }

         var6 = DecimalHelper.multi(var4, var15, 6);
         this.setItemValue(var1, "goodsqty", var6);
         this.a(var1);
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   private void a(int var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange");
      String var3 = this.getItemValue(var1, "unitprice");
      String var4 = this.getItemValue(var1, "goodsqty");
      String var5 = this.getItemValue(var1, "taxrate");
      if (!var2.equals("") && !var2.equals("0") && !var2.equals("0.0000")) {
         var3 = DecimalHelper.multi(var3, var2, 10);
      }

      var3 = DecimalHelper.divide(var2 = DecimalHelper.multi(var3, var4, 2), DecimalHelper.add("1", var5, 10), 2);
      this.setItemValue(var1, "total_line", var2);
      this.setItemValue(var1, "notaxmoney", var3);
   }

   private boolean b(int var1) {
      boolean var2 = false;
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      String var4 = this.getItemValue(var1, "goodsid");
      String var5 = this.getItemValue(var1, "batchid");
      if (var3 != null && !var3.equals("")) {
         ClientRequest var6 = new ClientRequest();
         StringCommand var7 = new StringCommand("禁销限销判断");
         ParamCommand var8;
         (var8 = new ParamCommand()).addParam("customid", var3);
         var8.addParam("goodsid", var4);
         var8.addParam("batchid", var5);
         ClientUserManager.getCurrentUser().getEntryid();
         var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
         var8.addParam("entryid", var3);
         var6.addCommand(var7);
         var6.addCommand(var8);
         ServerResponse var10 = null;

         try {
            var10 = SendHelper.sendRequest(var6);
         } catch (Exception var9) {
            var9.printStackTrace();
         }

         StringCommand var11 = (StringCommand)var10.commandAt(0);
         var5 = null;
         if (var11.getString().startsWith("+OK")) {
            var5 = ((StringCommand)var10.commandAt(1)).getString();
            if ("true".equals(var5)) {
               var2 = true;
            } else {
               var2 = false;
            }
         }

         if (!var2) {
            this.infoMessage("提示", "此货品禁止对本客户销售,请重新选择");
            this.setItemValue(var1, "opcode", "");
         }

         return var2;
      } else {
         this.infoMessage("提示", "请先录入客户");
         this.setItemValue(var1, "opcode", "");
         return false;
      }
   }

   private boolean c(int var1) {
      String var2 = "";
      DBTableModel var3 = null;
      String var6 = this.getItemValue(var1, "priceid");
      var6 = " select modifyflag  from pub_price_type where priceid = " + var6;
      RemotesqlHelper var4 = new RemotesqlHelper();

      try {
         var3 = var4.doSelect(var6, 0, 1);
      } catch (Exception var5) {
         this.a.error("error", var5);
         this.errorMessage("错误", var5.getMessage());
      }

      if (var3 != null && var3.getRowCount() > 0) {
         var2 = var3.getItemValue(0, "modifyflag");
      }

      boolean var7;
      if ("1".equals(var2)) {
         var7 = true;
      } else {
         var7 = false;
      }

      return var7;
   }

   public boolean canInvokehov(String var1) {
      if (var1.equals("priceopcode")) {
         var1 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var2 = this.getItemValue(this.getRow(), "goodsid");
         if (var1 == null || var1.equals("")) {
            this.infoMessage("提示", "请先录入客户！");
            return false;
         }

         if (var2 == null || var2.equals("")) {
            this.infoMessage("提示", "请先录入货品！");
            return false;
         }
      }

      return true;
   }

   public String getHovOtherWheres(int var1, String var2) {
      if (!"goodsid".equals(var2)) {
         String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var4 = this.getItemValue(var1, "goodsid");
         if (var2.equals("priceopcode")) {
            return "(customid is null or customid = " + var3 + ") and goodsid = " + var4 + " and entryid=" + ((Bms_sales_mde)this.mdemodel).getEntryid();
         }
      }

      return super.getHovOtherWheres(var1, var2);
   }

   public void doNew() {
      if (this.on_beforeNew() == 0) {
         super.doNew();
         int var1 = this.getRow();
         this.invokeMultimdehov(var1, "opcode", "");
      }

   }

   protected void invokeMultimdehov(int var1, String var2, String var3) {
      if (var2.equalsIgnoreCase("opcode")) {
         boolean var9 = false;
         boolean var10 = false;
         boolean var12 = false;
         boolean var4 = false;
         String var5 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到批号");
         String var6 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到批次");
         String var7 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到货位");
         String var8 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到货品状态");
         if ("1".equals(var5)) {
            var9 = true;
         }

         if ("1".equals(var6)) {
            var10 = true;
         }

         if ("1".equals(var7)) {
            var12 = true;
         }

         if ("1".equals(var8)) {
            var4 = true;
         }

         this.b.setGoodsdtlflag(true);
         this.b.setLotflag(var9);
         this.b.setBatchflag(var10);
         this.b.setPosflag(var12);
         this.b.setUsestatusflag(var4);
         this.b.setHovcallback(this);
         String var11 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "stsetid");
         var2 = " exists (select storageid from bms_st_def where  bms_st_def.storageid=bms_stqty_union_v.storageid ) ";
         if (!"".equals(var11)) {
            var2 = " exists (select storageid from bms_st_set_dtl where stsetid = " + var11 + " and bms_st_set_dtl.storageid=bms_stqty_union_v.storageid ) ";
         }

         this.b.showDialog(this.getParentFrame(), "选择货品输入数量", "settletypeid", "", var2);
         this.setFocus("goodsuseunit");
      }

   }

   public int hovcallback_itemvaluechanged(int var1, String var2, String var3, DBTableModel var4) {
      if (!var2.equalsIgnoreCase("editgoodsqty") && !var2.equalsIgnoreCase("editpackqty")) {
         return 0;
      } else if (var4.getItemValue(var1, "editgoodsqty").length() == 0) {
         return 0;
      } else {
         int var5 = this.getRow();
         this.setItemValue(var5, "goodsid", var4.getItemValue(var1, "goodsid"));
         this.setItemValue(var5, "opcode", var4.getItemValue(var1, "opcode"));
         this.setItemValue(var5, "goodsno", var4.getItemValue(var1, "goodsno"));
         this.setItemValue(var5, "goodsname", var4.getItemValue(var1, "goodsname"));
         this.setItemValue(var5, "currencyname", var4.getItemValue(var1, "currencyname"));
         this.setItemValue(var5, "goodstype", var4.getItemValue(var1, "goodstype"));
         this.setItemValue(var5, "goodsunit", var4.getItemValue(var1, "goodsunit"));
         this.setItemValue(var5, "prodara", var4.getItemValue(var1, "prodara"));
         this.setItemValue(var5, "factoryname", var4.getItemValue(var1, "factoryname"));
         this.setItemValue(var5, "factoryid", var4.getItemValue(var1, "factoryid"));
         this.setItemValue(var5, "goodsdtlid", var4.getItemValue(var1, "goodsdtlid"));
         this.setItemValue(var5, "packname", var4.getItemValue(var1, "packname"));
         this.setItemValue(var5, "packsize", var4.getItemValue(var1, "packsize"));
         this.setItemValue(var5, "goodsqty", var4.getItemValue(var1, "editgoodsqty"));
         this.setItemValue(var5, "goodsuseunit", var4.getItemValue(var1, "goodsunit"));
         this.setItemValue(var5, "goodsuseqty", var4.getItemValue(var1, "editgoodsqty"));
         this.setItemValue(var5, "batchno", var4.getItemValue(var1, "batchno"));
         this.setItemValue(var5, "batchid", var4.getItemValue(var1, "batchid"));
         this.setItemValue(var5, "lotno", var4.getItemValue(var1, "lotno"));
         this.setItemValue(var5, "invaliddate", var4.getItemValue(var1, "invaliddate"));
         this.setItemValue(var5, "lotid", var4.getItemValue(var1, "lotid"));
         this.setItemValue(var5, "posno", var4.getItemValue(var1, "posno"));
         this.setItemValue(var5, "posid", var4.getItemValue(var1, "posid"));
         this.setItemValue(var5, "goodsstatus", var4.getItemValue(var1, "goodsstatus"));
         this.setItemValue(var5, "goodsstatusid", var4.getItemValue(var1, "goodsstatusid"));
         this.setItemValue(var5, "storageid", var4.getItemValue(var1, "storageid"));
         this.setItemValue(var5, "storagename", var4.getItemValue(var1, "storagename"));
         this.setItemValue(var5, "storageno", var4.getItemValue(var1, "storageno"));
         this.setItemValue(var5, "storageopcode", var4.getItemValue(var1, "storageopcode"));
         this.setItemValue(var5, "wholesaleprice", var4.getItemValue(var1, "wholesaleprice"));
         this.setItemValue(var5, "resaleprice", var4.getItemValue(var1, "resaleprice"));
         this.setItemValue(var5, "prodarea", var4.getItemValue(var1, "prodarea"));
         this.on_itemvaluechange(var5, "goodsid", var4.getItemValue(var1, "goodsid"));
         this.tableChanged(var5);
         return 1;
      }
   }

   public void hovcallback_ok(int var1, DBTableModel var2, CTable var3) {
   }

   public void hovcallback_cancel() {
   }

   public boolean hovcallback_checkresult(int var1, DBTableModel var2, CTable var3) {
      return true;
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "allowbackflag", "1");
      this.setItemValue(var1, "correctflag", "0");
      return super.on_new(var1);
   }

   protected int on_beforemodify(int var1) {
      this.setFocus("opcode");
      return super.on_beforemodify(var1);
   }

   public void on_doubleclick(int var1, int var2) {
      this.setFocus("opcode");
      super.on_doubleclick(var1, var2);
   }

   protected String getEditablecolumns(int var1) {
      int var2 = this.mdemodel.getMasterModel().getRow();
      String var3 = this.mdemodel.getMasterModel().getItemValue(var2, "usestatus");
      String var5 = this.mdemodel.getMasterModel().getItemValue(var2, "approveflag");
      String var4 = this.getItemValue(var1, "priceid");
      if ("2".equals(var3) && "0".equals(var5) && !"".equals(var4) && var1 >= 0 && var1 < this.getRowCount()) {
         return this.c(var1) ? "opcode,goodsuseunit,goodsuseqty,priceopcode,unitprice,discount,allowbackflag,dtlmemo" : "opcode,goodsuseunit,goodsuseqty,priceopcode,allowbackflag,dtlmemo";
      } else {
         return super.getEditablecolumns(var1);
      }
   }
}
